Realm-xcframeworks.sh 4.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157
  1. #!/bin/sh
  2. set -e
  3. set -u
  4. set -o pipefail
  5. function on_error {
  6. echo "$(realpath -mq "${0}"):$1: error: Unexpected failure"
  7. }
  8. trap 'on_error $LINENO' ERR
  9. # This protects against multiple targets copying the same framework dependency at the same time. The solution
  10. # was originally proposed here: https://lists.samba.org/archive/rsync/2008-February/020158.html
  11. RSYNC_PROTECT_TMP_FILES=(--filter "P .*.??????")
  12. variant_for_slice()
  13. {
  14. case "$1" in
  15. "realm-monorepo.xcframework/macos-x86_64_arm64")
  16. echo ""
  17. ;;
  18. "realm-monorepo.xcframework/ios-arm64_armv7")
  19. echo ""
  20. ;;
  21. "realm-monorepo.xcframework/ios-arm64_x86_64_i386-simulator")
  22. echo "simulator"
  23. ;;
  24. "realm-monorepo.xcframework/ios-arm64_x86_64-maccatalyst")
  25. echo "maccatalyst"
  26. ;;
  27. "realm-monorepo.xcframework/watchos-armv7k_arm64_32_arm64")
  28. echo ""
  29. ;;
  30. "realm-monorepo.xcframework/watchos-arm64_i386_x86_64-simulator")
  31. echo "simulator"
  32. ;;
  33. "realm-monorepo.xcframework/tvos-arm64")
  34. echo ""
  35. ;;
  36. "realm-monorepo.xcframework/tvos-arm64_x86_64-simulator")
  37. echo "simulator"
  38. ;;
  39. esac
  40. }
  41. archs_for_slice()
  42. {
  43. case "$1" in
  44. "realm-monorepo.xcframework/macos-x86_64_arm64")
  45. echo "arm64 x86_64"
  46. ;;
  47. "realm-monorepo.xcframework/ios-arm64_armv7")
  48. echo "arm64 armv7"
  49. ;;
  50. "realm-monorepo.xcframework/ios-arm64_x86_64_i386-simulator")
  51. echo "arm64 i386 x86_64"
  52. ;;
  53. "realm-monorepo.xcframework/ios-arm64_x86_64-maccatalyst")
  54. echo "arm64 x86_64"
  55. ;;
  56. "realm-monorepo.xcframework/watchos-armv7k_arm64_32_arm64")
  57. echo "arm64 arm64_32 armv7k"
  58. ;;
  59. "realm-monorepo.xcframework/watchos-arm64_i386_x86_64-simulator")
  60. echo "arm64 i386 x86_64"
  61. ;;
  62. "realm-monorepo.xcframework/tvos-arm64")
  63. echo "arm64"
  64. ;;
  65. "realm-monorepo.xcframework/tvos-arm64_x86_64-simulator")
  66. echo "arm64 x86_64"
  67. ;;
  68. esac
  69. }
  70. copy_dir()
  71. {
  72. local source="$1"
  73. local destination="$2"
  74. # Use filter instead of exclude so missing patterns don't throw errors.
  75. echo "rsync --delete -av "${RSYNC_PROTECT_TMP_FILES[@]}" --links --filter \"- CVS/\" --filter \"- .svn/\" --filter \"- .git/\" --filter \"- .hg/\" \"${source}*\" \"${destination}\""
  76. rsync --delete -av "${RSYNC_PROTECT_TMP_FILES[@]}" --links --filter "- CVS/" --filter "- .svn/" --filter "- .git/" --filter "- .hg/" "${source}"/* "${destination}"
  77. }
  78. SELECT_SLICE_RETVAL=""
  79. select_slice() {
  80. local xcframework_name="$1"
  81. xcframework_name="${xcframework_name##*/}"
  82. local paths=("${@:2}")
  83. # Locate the correct slice of the .xcframework for the current architectures
  84. local target_path=""
  85. # Split archs on space so we can find a slice that has all the needed archs
  86. local target_archs=$(echo $ARCHS | tr " " "\n")
  87. local target_variant=""
  88. if [[ "$PLATFORM_NAME" == *"simulator" ]]; then
  89. target_variant="simulator"
  90. fi
  91. if [[ ! -z ${EFFECTIVE_PLATFORM_NAME+x} && "$EFFECTIVE_PLATFORM_NAME" == *"maccatalyst" ]]; then
  92. target_variant="maccatalyst"
  93. fi
  94. for i in ${!paths[@]}; do
  95. local matched_all_archs="1"
  96. local slice_archs="$(archs_for_slice "${xcframework_name}/${paths[$i]}")"
  97. local slice_variant="$(variant_for_slice "${xcframework_name}/${paths[$i]}")"
  98. for target_arch in $target_archs; do
  99. if ! [[ "${slice_variant}" == "$target_variant" ]]; then
  100. matched_all_archs="0"
  101. break
  102. fi
  103. if ! echo "${slice_archs}" | tr " " "\n" | grep -F -q -x "$target_arch"; then
  104. matched_all_archs="0"
  105. break
  106. fi
  107. done
  108. if [[ "$matched_all_archs" == "1" ]]; then
  109. # Found a matching slice
  110. echo "Selected xcframework slice ${paths[$i]}"
  111. SELECT_SLICE_RETVAL=${paths[$i]}
  112. break
  113. fi
  114. done
  115. }
  116. install_xcframework() {
  117. local basepath="$1"
  118. local name="$2"
  119. local package_type="$3"
  120. local paths=("${@:4}")
  121. # Locate the correct slice of the .xcframework for the current architectures
  122. select_slice "${basepath}" "${paths[@]}"
  123. local target_path="$SELECT_SLICE_RETVAL"
  124. if [[ -z "$target_path" ]]; then
  125. echo "warning: [CP] $(basename ${basepath}): Unable to find matching slice in '${paths[@]}' for the current build architectures ($ARCHS) and platform (${EFFECTIVE_PLATFORM_NAME-${PLATFORM_NAME}})."
  126. return
  127. fi
  128. local source="$basepath/$target_path"
  129. local destination="${PODS_XCFRAMEWORKS_BUILD_DIR}/${name}"
  130. if [ ! -d "$destination" ]; then
  131. mkdir -p "$destination"
  132. fi
  133. copy_dir "$source/" "$destination"
  134. echo "Copied $source to $destination"
  135. }
  136. install_xcframework "${PODS_ROOT}/Realm/core/realm-monorepo.xcframework" "Realm" "library" "ios-arm64_armv7" "ios-arm64_x86_64_i386-simulator" "ios-arm64_x86_64-maccatalyst"